/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM /usr/src/packages/BUILD/build-tree/mozilla/netwerk/base/public/nsIInputStreamChannel.idl
 */

#ifndef __gen_nsIInputStreamChannel_h__
#define __gen_nsIInputStreamChannel_h__


#ifndef __gen_nsIChannel_h__
#include "nsIChannel.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIInputStream; /* forward declaration */

class nsIOutputStream; /* forward declaration */


/* starting interface:    nsIChannelStreamAdaptor */
#define NS_ICHANNELSTREAMADAPTOR_IID_STR "274c4d7a-2447-4ceb-a6de-80db1b83f5d2"

#define NS_ICHANNELSTREAMADAPTOR_IID \
  {0x274c4d7a, 0x2447, 0x4ceb, \
    { 0xa6, 0xde, 0x80, 0xdb, 0x1b, 0x83, 0xf5, 0xd2 }}

/**
 * nsIChannelStreamAdaptor
 *
 * This interface provides methods to initialize an input stream channel.
 * The input stream channel serves as a data pump for an input stream.
 */
class NS_NO_VTABLE nsIChannelStreamAdaptor : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ICHANNELSTREAMADAPTOR_IID)

  /**
     * Sets the URI for this channel.  This must be called before the
     * channel is opened, and it may only be called once.
     */
  /* void setURI (in nsIURI aURI); */
  NS_IMETHOD SetURI(nsIURI *aURI) = 0;

  /**
     * Get/set the content stream
     *
     * This stream contains the data that will be pushed to the channel's
     * stream listener.  If the stream is non-blocking and supports the
     * nsIAsyncInputStream interface, then the stream will be read directly.
     * Otherwise, the stream will be read on a background thread.
     *
     * This attribute must be set before the channel is opened, and it may
     * only be set once.
     *
     * @throws NS_ERROR_IN_PROGRESS if the setter is called after the channel
     * has been opened.
     */
  /* attribute nsIInputStream contentStream; */
  NS_IMETHOD GetContentStream(nsIInputStream * *aContentStream) = 0;
  NS_IMETHOD SetContentStream(nsIInputStream * aContentStream) = 0;

  /**
     * Get/set the output stream
     *
     * This stream is the destination for data pushed to the channel
     * If the stream is non-blocking and supports the nsIAsyncOutputStream
     * interface, then the stream will be written to directly.
     * Otherwise, the stream will be written to on a background thread.
     *
     * This attribute must be set before the channel is opened, and it may
     * only be set once.
     *
     * @throws NS_ERROR_IN_PROGRESS if the setter is called after the channel
     * has been opened.
     */
  /* attribute nsIOutputStream outputStream; */
  NS_IMETHOD GetOutputStream(nsIOutputStream * *aOutputStream) = 0;
  NS_IMETHOD SetOutputStream(nsIOutputStream * aOutputStream) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIChannelStreamAdaptor, NS_ICHANNELSTREAMADAPTOR_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSICHANNELSTREAMADAPTOR \
  NS_IMETHOD SetURI(nsIURI *aURI); \
  NS_IMETHOD GetContentStream(nsIInputStream * *aContentStream); \
  NS_IMETHOD SetContentStream(nsIInputStream * aContentStream); \
  NS_IMETHOD GetOutputStream(nsIOutputStream * *aOutputStream); \
  NS_IMETHOD SetOutputStream(nsIOutputStream * aOutputStream); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSICHANNELSTREAMADAPTOR(_to) \
  NS_IMETHOD SetURI(nsIURI *aURI) { return _to SetURI(aURI); } \
  NS_IMETHOD GetContentStream(nsIInputStream * *aContentStream) { return _to GetContentStream(aContentStream); } \
  NS_IMETHOD SetContentStream(nsIInputStream * aContentStream) { return _to SetContentStream(aContentStream); } \
  NS_IMETHOD GetOutputStream(nsIOutputStream * *aOutputStream) { return _to GetOutputStream(aOutputStream); } \
  NS_IMETHOD SetOutputStream(nsIOutputStream * aOutputStream) { return _to SetOutputStream(aOutputStream); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSICHANNELSTREAMADAPTOR(_to) \
  NS_IMETHOD SetURI(nsIURI *aURI) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetURI(aURI); } \
  NS_IMETHOD GetContentStream(nsIInputStream * *aContentStream) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetContentStream(aContentStream); } \
  NS_IMETHOD SetContentStream(nsIInputStream * aContentStream) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetContentStream(aContentStream); } \
  NS_IMETHOD GetOutputStream(nsIOutputStream * *aOutputStream) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOutputStream(aOutputStream); } \
  NS_IMETHOD SetOutputStream(nsIOutputStream * aOutputStream) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetOutputStream(aOutputStream); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsChannelStreamAdaptor : public nsIChannelStreamAdaptor
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSICHANNELSTREAMADAPTOR

  nsChannelStreamAdaptor();

private:
  ~nsChannelStreamAdaptor();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsChannelStreamAdaptor, nsIChannelStreamAdaptor)

nsChannelStreamAdaptor::nsChannelStreamAdaptor()
{
  /* member initializers and constructor code */
}

nsChannelStreamAdaptor::~nsChannelStreamAdaptor()
{
  /* destructor code */
}

/* void setURI (in nsIURI aURI); */
NS_IMETHODIMP nsChannelStreamAdaptor::SetURI(nsIURI *aURI)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIInputStream contentStream; */
NS_IMETHODIMP nsChannelStreamAdaptor::GetContentStream(nsIInputStream * *aContentStream)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsChannelStreamAdaptor::SetContentStream(nsIInputStream * aContentStream)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIOutputStream outputStream; */
NS_IMETHODIMP nsChannelStreamAdaptor::GetOutputStream(nsIOutputStream * *aOutputStream)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsChannelStreamAdaptor::SetOutputStream(nsIOutputStream * aOutputStream)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIInputStreamChannel_h__ */
